//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
      pEnum=0;
      pSvc=0;
      pLoc=0;
      pSerialDev=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
Button1->Enabled=false;
HRESULT hres;

hres = CoInitializeEx(0, COINIT_MULTITHREADED); //Initialize COM.

if (FAILED(hres))
   { ShowMessage("Failed to initialize COM library. Error code = "+IntToHex((int)hres,8));
     Application->Terminate();
   }
hres =  CoInitializeSecurity(
  NULL,         // security descriptor
  -1,           // use this simple setting
  NULL,         // use this simple setting
  NULL,         // reserved
  RPC_C_AUTHN_LEVEL_CONNECT,     // Windows NT 4/Windows 2000 authentication level
  RPC_C_IMP_LEVEL_IMPERSONATE,   // impersonation level
  NULL,         // use this simple setting
  EOAC_NONE,    // no special capabilities
  0);           // reserved

  if (FAILED(hres))
  {
     ShowMessage("Failed to initialize security. Error code = "+IntToHex((int)hres,8));
     CoUninitialize();
     Application->Terminate();
  }

//IWbemLocator interface for obtaining the initial namespace pointer to
//the Windows Management on a particular host computer.
    hres = CoCreateInstance(CLSID_WbemLocator, 0,
        CLSCTX_INPROC_SERVER, IID_IWbemLocator, (LPVOID *) &pLoc);

    if (FAILED(hres))
    {
     ShowMessage("Failed to create IWbemLocator object. Err code = "+IntToHex((int)hres,8));
     CoUninitialize();
     Application->Terminate();
    }

    hres = pLoc->ConnectServer(
            L"\\\\.\\root\\cimv2",
            NULL, NULL, 0, NULL, 0, 0, &pSvc);


    if (FAILED(hres))
    {
     ShowMessage("Could not connect. Error code = "+IntToHex((int)hres,8));
     CoUninitialize();
     Application->Terminate();
    }

// Set the proxy so that impersonation of the client occurs.
hres = CoSetProxyBlanket(pSvc,
  RPC_C_AUTHN_WINNT,    // NTLM authentication service
  RPC_C_AUTHZ_NONE,     // default authorization service...
  NULL,                 // no mutual authentication
  RPC_C_AUTHN_LEVEL_CONNECT,      // authentication level
  RPC_C_IMP_LEVEL_IMPERSONATE,    // impersonation level
  NULL,                // use current token
  EOAC_NONE);          // no special capabilities



    if (FAILED(hres))
    {
      ShowMessage("Could not set proxy blanket. Error code = "+IntToHex((int)hres,8));
      pSvc->Release();
      pLoc->Release();
      CoUninitialize();
      Application->Terminate();
    }

//Win32_SerialPort - WMI class that contains information about serial ports
BSTR className = SysAllocString(L"Win32_SerialPort");

  hres = pSvc->GetObject(className, 0, NULL, &pSerialDev, NULL );
//Retrieves an class object.

  ULONG puReturned;

//Create instance for enumeration ports

  hres=pSvc->CreateInstanceEnum(
  className,
  NULL,
  NULL,
  &pEnum
);

//no need in variable className now.
SysFreeString(className);

    if (hres != 0)
    {
        ShowMessage("Error");
        Application->Terminate();
    }

    // Retrieve the objects in the result set.
    for (;;)
    {
        VARIANT Val;
        CIMTYPE pvtType;
        ULONG uReturned = 0;

        VariantInit(&Val);

        hres = pEnum->Next(
            WBEM_INFINITE,                  // Time out
            1,                  // One object
            &pSerialDev,
            &uReturned
            );

        if (uReturned == 0)
            break;

        //get name for every port and add it in the list box...
        BSTR Name = SysAllocString(L"Name");
        pSerialDev->Get(Name,0,&Val,&pvtType,NULL);
        LPSTR SS=WideToAnsi(Val.bstrVal);
        ListBox1->Items->Add(SS);
        SysFreeString(Name);
        delete []SS;
        //... and free it.

        VariantClear(&Val);
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
if(ListBox1->ItemIndex >= 0)Form2->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
Form3->ShowModal();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    // All done.
if(pEnum)pEnum->Release();
if(pSvc)pSvc->Release();
if(pLoc)pLoc->Release();
if(pSerialDev)pSerialDev->Release();
CoUninitialize();
}
//---------------------------------------------------------------------------

